import { Schema, Messages, TypedSchema, ParsedTypedSchema } from 'indicative-parser';
import { ErrorFormatterContract, ErrorCollectorFn } from 'indicative-compiler';
export declare type ValidatorConfig = {
    cacheKey?: string;
    existyStrict: boolean;
    removeAdditional: boolean;
    customErrorCollector?: ErrorCollectorFn;
    formatter: {
        new (): ErrorFormatterContract;
    };
};
export declare type SanitizerConfig = {
    cacheKey?: string;
};
export declare type ValidateFn = <T extends ParsedTypedSchema<TypedSchema> | Schema>(data: any, schema: T, messages?: Messages, config?: Partial<ValidatorConfig>) => T extends Schema ? Promise<any> : Promise<T['props']>;
export declare type SanitizeFn = (data: any, schema: Schema, config?: Partial<SanitizerConfig>) => any;
