"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const indicative_rules_1 = require("indicative-rules");
const indicative_compiler_1 = require("indicative-compiler");
const CacheManager_1 = require("../CacheManager");
const cacheManager = new CacheManager_1.CacheManager();
function getExecutor(schema, config) {
    if (!config.cacheKey) {
        const compiler = new indicative_compiler_1.SanitizerCompiler(schema, indicative_rules_1.sanitizations);
        return new indicative_compiler_1.SanitizerExecutor(compiler.compile());
    }
    const compiledSchema = cacheManager.get(config.cacheKey);
    if (!compiledSchema) {
        const compiler = new indicative_compiler_1.SanitizerCompiler(schema, indicative_rules_1.sanitizations);
        cacheManager.set(config.cacheKey, compiler.compile());
    }
    return new indicative_compiler_1.SanitizerExecutor(cacheManager.get(config.cacheKey));
}
exports.sanitize = (data, schema, config) => {
    config = config || {};
    return getExecutor(schema, config).exec(data, config);
};
